#!/usr/bin/perl

# **
# * ------------------------------------------------------------------------
# * BlueMind Stats Portal, aka bm-stats
# * ------------------------------------------------------------------------
# * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>
# * @author  : Pascal SALAUN 
# * @Website : http://www.breizh-ltd.com <http://www.breizh-ltd.com>
# * ------------------------------------------------------------------------
# **

BEGIN {
    push @INC,"/usr/share/bm-stats/scripts/PERL/";
};

require "bmFunctions.pl";

#use strict;
use List::Util qw(sum);
use Date::Calc qw(Week_Number Mktime);
use Encode ;
use File::Path ;
use File::Copy ;
use Data::Dumper qw(Dumper) ;

######################################
#
# Var settings
#
######################################




my $limit = 5; #only the last $limit (minutes) lines are parsed 
my $maxElementInObmCyrusLoggedConnexion = 10 ;

our $bm_ini_file = "/etc/bm/bm.ini";
my $path_to_data_dir = "/var/lib/bm-stats/" ;

# the current mail log file
my $file     = "mail.log" ;

# yesterday mail.log file 
my $prevFile = "mail.log.0" ;


# init mail log file name  
my $thisFile = $file  ;

# init luanch mktime 
my $mktime = time() ;

# if parsing at 00:00 
my $when = `date +%H:%M`;
if ($when eq "00:00") {
	$thisFile = $prevFile ;	
}; 

my $path_to_log_file = "/var/log/";
my $log_file = $path_to_log_file.$thisFile ;

my $this_dateTime = "" ;
my $this_proto = "" ;
my $this_ip = "" ;
my $this_address  = "" ;
my $this_UserAgentVersion = "" ;
my $this_hour = "";
my $this_gestionnaire = "";
my $superkey = ""  ;
my $this_vol = 0 ;
my $this_nrcpt = "" ;
my $this_SenderDomain= "" ;
my $this_RecipDomain = "" ;

            
my @prefixe = () ;
my @history = () ;

my %local_address = () ;
my %log = () ;
my %history = () ;
my %postfixId   = () ;

our %compteur        = ();
our %list_by_nb      = ();
our %list_by_vol     = ();
our %list_vol_by_msgID = ();
our %list_domain_by_postfixId = ();
our %senderDomainByGestionnaire = ();
our %localSender = () ;


#
###################################################################

#######################################
#
# Job starting HERE
#
#######################################




# Liste des minutes à prendre en compte
my ($dbt,$liste_dbt, $date) = &time_limit($limit);


#
# PHP exporting data from PostGreS through API
#

my $res = `/usr/bin/php5 /usr/share/bm-stats/scripts/PHP/api/listAllMailbox.php` ;
   $res =~ s/\n//;

%local_address = split (/ /,$res) ;

foreach $this_address (keys %local_address) {

    $this_gestionnaire = $local_address{$this_address};
    @prefixe = split(/\@/,$this_address);
    $superkey = $prefixe[0];


    if( $superkey ne "") {
		
		# Setting account counters
		push @{$compteur{$this_gestionnaire}{'nbf'}},0 ;
		push @{$compteur{$this_gestionnaire}{'nbt'}},0 ;
		push @{$compteur{$this_gestionnaire}{'volt'}},0 ;
		push @{$compteur{$this_gestionnaire}{'volf'}},0 ;
		@{$compteur{$this_gestionnaire}{'nbT'}} = () ; # will be feed as "push @{$compteur{...}}, (x => y);"
    
		
		$log{$this_gestionnaire}{$superkey}{'log'} = "NONE" ;
		$log{$this_gestionnaire}{$superkey}{'userAgent'} = "NONE" ;
		
    };
};


#print Dumper(\\%local_address) ;

#
# LogFile Parse
#
# A quel endroit se positionner directement dans le fichier
my $start_pos=`grep -m 1 -b "$dbt" $log_file | cut -d : -f1`;

open(F, $log_file) || die "Error while opening : $!";
seek F, $start_pos,0 ;

while(<F>) {

	$this_dateTime = "" ;
	$this_proto    = "" ;
 	$this_ip       = "" ;
	$this_address  = "" ;

	if($_ =~ m%^($liste_dbt)%) {
		#print "$_ \n";
	} else { 
        next; 
    };
    
    #List of message_id
    #Aug 22 20:09:21 galadriel postfix/cleanup[11415]: 6C54B9E433D: message-id=<20090822200921.9q4fg64u0wg4swkw@mail.mclabosse.fr>
    #             1          2            3       4                 5
    if ( $_ =~ m%(.*)(postfix/cleanup)\[(\d+)\]: (.*): message-id=<?(.*)>?.*% ) {
 
        # want to keep only one "from" line per message.
        # the same message_id can be found twice
        my $this_msgID = $5 ;
        $this_queueId = $4 ;    
                                                                                               
        my %ReversePostfixId = reverse %postfixId ;
        if( exists($ReversePostfixId{$this_msgID}) ) {
    
        } else {
            $postfixId{$this_queueId} = $this_msgID;
        };
    };


	# Case of originators and volume/mail
	# Aug 22 15:38:15 galadriel postfix/qmgr[4158]: 7E83C9E4318: from=<frodon.saquet@laposte.net>, size=1767, nrcpt=1 (queue active)
	#              1        2          3      4           5           6            7
	if ( $_ =~ m%(.*)(postfix/.*)\[(\d+)\]: (.*): from=<(.*)>, size=(\d+), nrcpt=(\d+) .*% ) {
             
		$this_queueId = $4 ;

		if( exists $postfixId{$this_queueId} ) {

			$this_nrcpt   = $7 ;
			$this_vol     = $6 ;
			$this_address = $5 ;
             
            my $thisMsgId = $postfixId{$this_queueId} ;

			$list_vol_by_msgID{$postfixId{$this_queueId}} = $this_vol ;
			
            # print "From $this_address $this_vol "; 
			
            $this_gestionnaire = "" ;
			@prefixe = split(/\\\@/,$this_address);
			$superkey = $prefixe[0];

			if ( exists $local_address{$this_address} ) {

				$this_gestionnaire = $local_address{$this_address};
				# Local Sender
				$localSender{$thisMsgId} = $this_gestionnaire ;

				push @{$compteur{$this_gestionnaire}{'nbf'}},1;
				push @{$compteur{$this_gestionnaire}{'volf'}},$this_vol;
			};
	
    	};
	
    };

	# Case of destinators (successfull dsn=2.*.*)
	#             1     2       3     4        5          6      7                    
	if ( $_ =~ m%(.*)(postfix/)(.*)\[(\d+)\]: (.*): to=<(.*@.*)>, (.*)status=sent.*% ) {
                            
		$this_queueId = $5 ;                
		my $to_block = $6 ;

        
		if( exists($postfixId{$this_queueId}) ) {


			#Case of "from a mailing-list"
			#frodon.saquet@laposte.net>, orig_to=<a-list-from-somewhere@list.obm.org
			my @sub_adr = split(/>,/,$to_block);
			   $this_address = $sub_adr[0] ;

			my $thisMsgId = $postfixId{$this_queueId} ;


			# Case of local recip
			if (exists $local_address{$this_address} ) {
                              
				$this_gestionnaire = $local_address{$this_address};  
				
				# Global counters
				push @{$compteur{$this_gestionnaire}{'nbt'}},1 ;
				push @{$compteur{$this_gestionnaire}{'volt'}}, $list_vol_by_msgID{$thisMsgId};
				push @{$compteur{$this_gestionnaire}{'nbT'}},($thisMsgId => $list_vol_by_msgID{$thisMsgId}) ;
			};
		};    
	};


    ## Gestion de la connexion cyrus standard ##

    #May 25 09:23:11 galadriel cyrus/imap[2977]: login: localhost [127.0.0.1] blaise.pascal@cnrs.fr plaintext User logged in
    #May 25 09:23:12 galadriel cyrus/pop3[3766]: login: [1.2.3.4] albert.einstein@cnrs.fr PLAIN+TLS User logged in
    #            1             2                           3       4
    if($_ =~ m%(.*) cyrus/(imap|pop).?\[\d+\]: login: .*\[(.*)\] (.*) .* User logged in% ) {
		$this_dateTime = $1 ;
		my ($month,$day,$hour,$host) = split(" ",$this_dateTime);
        $this_proto    = $2 ;
        $this_ip       = $3 ;
        $this_address  = $4 ;
        #$this_address =~s/\@/\\\@/;

        $this_gestionnaire = "" ;
        @prefixe = split(/\@/,$this_address);
        $superkey = $prefixe[0];
		
		$this_gestionnaire = $local_address{$this_address};
        $log{$this_gestionnaire}{$superkey}{'log'} = "$date $hour $this_proto $this_ip" ;   
    };
    

    ## Gestion de la connexion cyrus via un partage ## 
    #            1                                  2           3 
    if( $_ =~ m%(.*) cyrus/imap\[\d+\]: open: user (.*) opened (.*)% ) {

        $this_dateTime = $1 ;
        my ($month,$day,$hour,$host) = split(" ",$this_dateTime);
        my @sharing = split("@", $2) ;
        my $Sharing = $sharing[0];
        $Sharing =~ tr/^/./ ;

        my @account = split("/",$3) ;
        my $superkey = $account[1];
				
        $log{$this_gestionnaire}{$superkey}{'log'} = "$date $hour par $Sharing" ;
    };

    
    ## Gestion de la version du client ##
    #Feb 12 14:41:14 uruviel postfix/cleanup[19080]: 76728724071: warning: header User-Agent: Mozilla/5.0 (Windows; U; Windows NT 6.1; fr; rv:1.9.2.28) Gecko/20120306 Thunderbird/3.1.20 from unknown[1.2.3.4]; from=<albert.einstein@cnrs.fr> to=<blaise.pascal@cnrs.fr> proto=ESMTP helo=<[10.253.33.17]>: thisUserAgent=Thunderbird/3.1.20
    #            1                                      2                                     3
    if($_ =~ m%(.*) postfix/cleanup\[\d+\]: .*; from=<(.*)> to=.*: thisUserAgent=Thunderbird/(.*)% ) {
		$this_address   = $2 ;
		$this_UserAgentVersion = $3 ;
        $this_gestionnaire = "" ;
        @prefixe = split(/\@/,$this_address);
        $superkey = $prefixe[0];
		
	        # Case of from=<FIMAD@address> but listed in LDAP 
		if ( $this_address =~ m%pref-(.*)% ) {
		
			if ( $local_address{$this_address} ) {
				$this_gestionnaire = $local_address{$this_address};
			};
						
			if ( $local_address{$1} ) {
				$this_gestionnaire = $local_address{$1};	
				$superkey =~ s/pref-// ;
			};

			$log{$this_gestionnaire}{$superkey}{'userAgent'} = "$this_UserAgentVersion" ;

		} else {
			$this_gestionnaire = $local_address{$this_address};
            $log{$this_gestionnaire}{$superkey}{'userAgent'} = "$this_UserAgentVersion" ;   
		};
    };
};

close(F) ;

#
## Fin du Parse 
#

#print Dumper(\\ %compteur); 

#
## Alimentation du fichier d'alimentation du lastCyrusConnexion.dat
#

foreach my $domain (keys(%log)) {

	if($domain =~ m%[a-zA-Z0-9]+%) {
        	%history = () ;

		#Control de la presence du dossier /userCyrusConnection
		my $this_user_dir  = $path_to_data_dir.$domain."/userCyrusConnection" ;
		&control_rep($this_user_dir);

        my $thisFileCyrus = $this_user_dir."/lastCyrusConnexionFile.dat" ;

		my @user = keys %{@log{$domain}};
        my $userHashKey = \@user ;
        %history = &readLastCyrusConnexionFile($thisFileCyrus, $userHashKey);
	

		foreach my $this_user (sort @user) {

			if ( $log{$domain}{$this_user}{'log'} eq "NONE" ) {
				next ;
			} else {
        	
        		push (@{$history{$this_user}} , $log{$domain}{$this_user}{'log'});
        		@{$history{$this_user}} = sort(@{$history{$this_user}}) ;	

				my $nbElement = @{$history{$this_user}} ;
		
				while( $nbElement >= $maxElementInObmCyrusLoggedConnexion ) {
					my @trash = shift @{$history{$this_user}} ;
			        	$nbElement = @array ;	
		        	};
   
				};
		};	
        
        # Erase the file
        open(Fcyrus,"> $thisFileCyrus") || die "Error while opening : $!";
        close(Fcyrus);

        # Feed the file
        open(Fcyrus,">> $thisFileCyrus") || die "Error while opening : $!";
        foreach $this_user (keys %history ) {
          
	    	if( $this_user =~ m%[a-z0-9.\-]+% ) {	 
        		 my $thisLine = $this_user.";".join (";", @{$history{$this_user}})."\n";
					print Fcyrus "$thisLine";
	    	};

        };
        	
		close(Fcyrus);

	};
	
};



#
## Alimentation du fichier d'alimentation du lastUserAgentConnexion.dat (thunderbird uniquement)
#

foreach my $domain (keys(%log)) {

	if($domain =~ m%[a-zA-Z0-9]+%) {
        %history = () ;

		#Control de la presence du dossier /userAgentConnection
		my $this_user_dir  = $path_to_data_dir.$domain."/userAgentConnection" ;
		&control_rep($this_user_dir);

        my $thisFileUserAgent = $this_user_dir."/lastUserAgentConnexionFile.dat" ;

		my @user = keys %{@log{$domain}};

		my $userHashKey = \@user ;
       	%history = &readLastUserAgentConnexionFile($thisFileUserAgent, $userHashKey);


		foreach my $this_user (sort @user) {
		
			if ( $log{$domain}{$this_user}{'userAgent'} eq "NONE" ) {
				next ;
			} else {
        		$history{$this_user} = $log{$domain}{$this_user}{'userAgent'};
        	};
		};

        # Erase the file
        open(FuserAgent,"> $thisFileUserAgent") || die "Error while opening : $!";
        close(FuserAgent);

        # Feed the file
        open(FuserAgent,">> $thisFileUserAgent") || die "Error while opening : $!";
        foreach $this_user (keys %history ) {
          
	       	if( $this_user =~ m%[a-z0-9.\-]+% ) {	 
        		my $thisLine = $this_user.";".$history{$this_user}."\n";
        		print FuserAgent "$thisLine";
	       	};

        };
        close(FuserAgent);

	};
	
};


foreach my $domain (keys(%compteur)) {

	my $dir = $path_to_data_dir.$domain ;
	my $thisRealTimeFile = $dir."/realTime.dat" ;
	
    my @historyKeyN = () ;

	%history = () ;
	%history = &readRealTimeFile($thisRealTimeFile);
	
	my ($nbT, $volT)     = &getEntryVolumeValues($compteur{$domain}{nbT}) ; # nb of message incoming, vol of messages incoming
	my $nbt              = sum( @{$compteur{$domain}{nbt}} );  # nb of messages filled 
	my $nbf              = sum( @{$compteur{$domain}{nbf}} );  # nb of messages outgoing
	my $volf             = sum( @{$compteur{$domain}{volf}} ); # volume outgoing 
	my $volt             = sum( @{$compteur{$domain}{volt}} ); # volume filled

	$history{$mktime} = "$nbT,$nbt,$volT,$volt,$nbf,$volf";
   
    @historyKey = sort (keys %history) ;

    $nbElement = @historyKey ;
    

    if ( $nbElement>144 ) {
        @historyKeyN = @historyKey[-144..-1];
    } else {
        @historyKeyN = @historyKey ;
    };

    	
    # Erase the file
    open(FrealTime,"> $thisRealTimeFile") || die "Error while opening : $!";
    close(FrealTime);
    
    # Feed the file
    open(FrealTime,">> $thisRealTimeFile") || die "Error while opening : $!";
    foreach my $key (@historyKeyN) { 
		my $thisLine = $key.";".$history{$key}."\n";
		print FrealTime "$thisLine";
    };
    
    close(FrealTime);
    
    
} ;



my $trash = `php5 /usr/share/bm-stats/scripts/PHP/do_graph/bmLastH12.php `;

