#!/usr/bin/php5
<?php
/**
 * ------------------------------------------------------------------------
 * BlueMind Stats Portal, aka bm-stats
 * ------------------------------------------------------------------------
 * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>
 * @author  : Pascal SALAUN 
 * @Website : http://www.breizh-ltd.com <http://www.breizh-ltd.com>
 * ------------------------------------------------------------------------
 **/
 
/* Fichier de conf (log/mdp) MySQL */
require("/usr/share/bm-stats/www/conf/config.php");
require("/usr/share/bm-stats/www/function/date.php");
require("/usr/share/bm-stats/www/function/lang.php");


/* Variables modifiables*/
$path_to_pChart = "/usr/share/bm-stats/scripts/PHP/pChart/" ;
$dataFile = "/var/lib/bm-stats/general/domainGeneralStat.dat";




/* DO NOT TOUCH AFTER */

if(date("z") == "0" ) { 
    $this_year = date("Y") - 1 ; 
} else { 
 $this_year = date("Y"); 
};


$mktime_yesterday = mktime(0,0,0,date("m"),date("d")-1,date("y"));
$this_year  = date("Y",$mktime_yesterday);
$this_week  = date("W",$mktime_yesterday);
$this_month = date("m",$mktime_yesterday);
$this_n_day   = date("z",$mktime_yesterday);


// Recup. des donnees 
$values = get_values() ;


// Creation des images
foreach (array_keys($values) as $domain) {
    if($domain != "date" and $domain != "GlobalServer" and $domain != "Externe" and $domain != "d" and $domain != "w") {
        
        $myLang = getLang($domain) ;
        if(!empty($myLang)) $lang=$myLang ;
        require("/usr/share/bm-stats/www/inc_lang/inc_lang_$lang.php");

        $this_lit_month = get_month($this_month); 
        $this_full_day = date("d",$mktime_yesterday)." ".$this_lit_month." ".$this_year;


        /* Liste des titres dans les graphes */
        $list_title['ingoing']['title']     = $do_graph_ingoing_title ;
        $list_title['outgoing']['title']    = $do_graph_outgoing_title ;
        $list_title['outgoingvol']['title'] = $do_graph_outgoingvol_title;

        $case_img = array(    
                    "outgoingvol" => array(    
                            "titley" => "$do_graph_outgoingvol_titley $this_year",
                            "titlem" => "$do_graph_outgoingvol_titlem $this_lit_month $this_year",
                            "titlew" => "$do_graph_outgoingvol_titlew $this_week ($this_year)",
                            "titled" => "$do_graph_outgoingvol_titled $this_full_day "
                            ),
                    "ingoing" => array(    
                            "titley"=> "$do_graph_ingoing_titley $this_year",
                            "titlem"=> "$do_graph_ingoing_titlem $this_lit_month $this_year",
                            "titlew"=> "$do_graph_ingoing_titlew $this_week ($this_year)",
                            "titled"=> "$do_graph_ingoing_titled  $this_full_day "
                            ),
                    "outgoing" => array(    
                            "titley"=> "$do_graph_outgoing_titley $this_year",
                            "titlem"=> "$do_graph_outgoing_titlem $this_lit_month $this_year",
                            "titlew"=> "$do_graph_outgoing_titlew $this_week ($this_year)",
                            "titled"=> "$do_graph_outgoing_titled $this_full_day "
                            ),
                    "ingoingVol" => array(
                            "titley"=> "$do_graph_ingoingVol_titley $this_year",
                            "titlem"=> "$do_graph_ingoingVol_titlem $this_lit_month $this_year",
                            "titlew"=> "$do_graph_ingoingVol_titlew $this_week ($this_year)",
                            "titled"=> "$do_graph_ingoingVol_titled  $this_full_day "
                            ),
                    "ingoingM" => array(
                            "titley"=> "$do_graph_ingoingM_titley $this_year",
                            "titlem"=> "$do_graph_ingoingM_titlem $this_lit_month $this_year",
                            "titlew"=> "$do_graph_ingoingM_titlew $this_week ($this_year)",
                            "titled"=> "$do_graph_ingoingM_titled  $this_full_day "
                            ),
                    "ingoingVolM" => array(
                            "titley"=> "$do_graph_ingoingVolM_titley $this_year",
                            "titlem"=> "$do_graph_ingoingVolM_titlem $this_lit_month $this_year",
                            "titlew"=> "$do_graph_ingoingVolM_titlew $this_week ($this_year)",
                            "titled"=> "$do_graph_ingoingVolM_titled  $this_full_day "
                           ),
                      );


        foreach(array_keys($case_img) as $case) {

            if(count($values[$domain]['y'][$case]) >1 ) {
                do_img($values,$domain,$case,"y") ;
            };
    
            if(count($values[$domain]['m'][$case]) >1 ) {    
                do_img($values,$domain,$case,"m") ;
            };
            
            if(count($values[$domain]['w'][$case]) >1 ) {
                do_img($values,$domain,$case,"w") ;
            };
            
            if(count($values[$domain]['d'][$case]) >1 ) {
                do_img($values,$domain,$case,"d") ;
            };
        };
    };
};


/* DO NOT TOUCH AFTER */

/* Debut des fonctions locales */


function verif_existence_rep($rep) {
    $PATH=$rep;
    if(!(is_dir($PATH))) {
        $cmd = "mkdir -p $PATH ; chmod -R 755 $PATH  ; chown -R root.www-data $PATH";
        exec($cmd);
    } else {
        $cmd = "chmod -R 755 $PATH ; chown -R root.www-data $PATH ";
        exec($cmd);
    };

};

function SetXScaleDate($value) {
    $jour = substr($value,8,2);
    $mois = substr($value,5,2);

    if($jour == "01") {
        $xscaled = $jour." ".get_month($mois) ;
    } else {    
        $xscaled = " " ;
    };
       
    return $xscaled ;
};

function get_values() {

    Global $this_year,$this_week,$this_month,$this_n_day,$dataFile  ;    

    $first_date_passed = "0" ;

    $values = array() ;
    $values['d']['hour']= array("00:59","01:59","02:59","03:59","04:59","05:59","06:59","07:59","08:59","09:59","10:59","11:59","12:59","13:59","14:59","15:59","16:59","17:59","18:59","19:59","20:59","21:59","22:59","23:59") ;
    $values['w']['hour']= array(
                    "L 00"," "," "," "," "," "," "," "," "," "," "," ","L 12"," "," "," "," "," "," "," "," "," "," ","",
                    "M 00"," "," "," "," "," "," "," "," "," "," "," ","M 12"," "," "," "," "," "," "," "," "," "," ","",
                    "M 00"," "," "," "," "," "," "," "," "," "," "," ","M 12"," "," "," "," "," "," "," "," "," "," ","",
                    "J 00"," "," "," "," "," "," "," "," "," "," "," ","J 12"," "," "," "," "," "," "," "," "," "," ","",    
                    "V 00"," "," "," "," "," "," "," "," "," "," "," ","V 12"," "," "," "," "," "," "," "," "," "," ","",
                    "S 00"," "," "," "," "," "," "," "," "," "," "," ","S 12"," "," "," "," "," "," "," "," "," "," ","",
                    "D 00"," "," "," "," "," "," "," "," "," "," "," ","D 12"," "," "," "," "," "," "," "," "," "," ",""
                    ) ;

    



	$data = file($dataFile);
	sort($data); 
	foreach($data as $line) {

        $ingoing     = 0 ;
        $ingoingVol  = 0 ;
        $outgoing    = 0 ;
        $outgoingvol = 0 ;
        $ingoingM    = 0 ;
        $ingoingVolM = 0 ;

		if(preg_match("/^$this_year/",$line)) {
			$val = explode(",",$line);
        
			$date = $val['0'];
				$this_X_dot = SetXScaleDate($date);
				$element = explode("-",$date);
				$element_year   = $element[0];         
				$element_month  = $element[1];
				$element_day    = $element[2];                     
				$element_mktime = mktime(0,0,0,$element_month,$element_day,$element_year) ;
				$element_n_day  = date("z",$element_mktime);
				$element_week   = date("W",$element_mktime);
				$element_num_day_of_week = date("N",$element_mktime) ;


			$domain      = $val['1'];
		
            $ingoing     = $val['2'] ; //posts filled
			$outgoing    = $val['27'] ; //posts sent
			$outgoingvol = floor($val['52']/1000000) ; //volume sent
            
            $ingoingVol  = floor($val['77']/1000000)  ; // volume filled
            $ingoingM    = $val['102'] ; // posts received 
            $ingoingVolM = floor($val['127']/1000000)  ; // volume posts received
            
			$values[$domain]['y']['date'][]        = $this_X_dot ;
			$values[$domain]['y']['ingoing'][]     = $ingoing ;
			$values[$domain]['y']['outgoing'][]    = $outgoing;
			$values[$domain]['y']['outgoingvol'][] = $outgoingvol;

            $values[$domain]['y']['ingoingVol'][]  = $ingoingVol ;
            $values[$domain]['y']['ingoingM'][]    = $ingoingM ;
            $values[$domain]['y']['ingoingVolM'][] = $ingoingVolM ;





			if( ($this_year==$element_year) and  ($this_month==$element_month) ) {        
				$values[$domain]['m']['date'][]        = $element_day;
				$values[$domain]['m']['ingoing'][]     = $ingoing ;
				$values[$domain]['m']['outgoing'][]    = $outgoing ;
				$values[$domain]['m']['outgoingvol'][] = $outgoingvol ;
                $values[$domain]['m']['ingoingVol'][]  = $ingoingVol ;
                $values[$domain]['m']['ingoingM'][]    = $ingoingM ;
                $values[$domain]['m']['ingoingVolM'][] = $ingoingVolM ;
			};

			if( ($this_year==$element_year) and  ($this_week==$element_week) ) {        
				if($first_date_passed =="0") {
					if($element_num_day_of_week >= 2 ) {
						$pos = ($element_num_day_of_week - 1)*24 ;
						$new_values = array_splice($values['w']['hour'],$pos);
						$values['w']['hour'] = $new_values ;
					};
					$first_date_passed = "1" ;
				};

				//Alim horaire de 00 -> 23
				$values[$domain]['w']['date'][] = $element_day;
                for($i = 3; $i<=26 ; $i++) {        
                	$values[$domain]['w']['ingoing'][] = $val[$i] + 0;
				};
                
                for ($j = 28 ; $j<=51 ; $j++) {  
				    $values[$domain]['w']['outgoing'][] = $val[$j] + 0;
				};

				for ($k = 53 ; $k<=76 ; $k++ ) { 
                    $values[$domain]['w']['outgoingvol'][] = floor($val[$k]/1000000) + 0;
				};
			
                for ($l = 78 ; $l<=101 ; $l++) {
                    $values[$domain]['w']['ingoingVol'][] = floor($val[$l]/1000000) + 0;
                };
               
                for ($m = 103 ; $m <=126 ; $m++) {
                    $values[$domain]['w']['ingoingM'][] = $val[$m] + 0;
                };

                for ($n = 128 ; $n <=151 ; $n++) {
                    $values[$domain]['w']['ingoingVolM'][] = floor($val[$n]/1000000) +0;
                }; 
            
            };

			if( ($this_year==$element_year) and  ($this_n_day==$element_n_day) ) {   

                for($i = 3; $i<=26 ; $i++) {
                    $values[$domain]['d']['ingoing'][] = $val[$i] + 0;
                };
                                                        
                for ($j = 28 ; $j<=51 ; $j++) {
                    $values[$domain]['d']['outgoing'][] = $val[$j] + 0;
                };
                
                for ($k = 53 ; $k<=76 ; $k++ ) {
                    $values[$domain]['d']['outgoingvol'][] = floor($val[$k]/1000000) + 0;
                };
                                                                                                                                                                        
                for ($l = 78 ; $l<=101 ; $l++) {
                    $values[$domain]['d']['ingoingVol'][] = floor($val[$l]/1000000) + 0;
                };
                
                for ($m = 103 ; $m <=126 ; $m++) {
                    $values[$domain]['d']['ingoingM'][] = $val[$m] + 0;
                };

                for ($n = 128 ; $n <=151 ; $n++) {
                    $values[$domain]['d']['ingoingVolM'][] = floor($val[$n]/1000000) + 0;
                };
			};
		};
	};
	    //$new_values = array_splice($values['w']['hour'],$pos);
	    //$values['w']['hour'] = $new_values ;

    return $values;
}; 


function setMo($value) {
    return round($value).' Mo';
};

function setRoundValue($value) {
        return round($value) ;
};



/*
array $values : extraction de la tables MySQL faite par get_values().
$domain       : autre que GlobalServer & Externe
$case         : ingoing,outgoing,outgoingvol (entrant, sortant,volume sortant)

*/
function do_img(&$values,$domain,$case,$type)
{
    Global $this_year,$this_week,$this_month,$this_n_day  ;
    Global $path_to_data,$path_to_pChart,$case_img;        
    Global $do_graph_domain, $do_graph_global_server, $do_graph_external_server;

    $path_to_img = $path_to_data.$domain."/img/".$this_year."/";
   

	/* pChart library inclusions */
	require_once $path_to_pChart."class/pData.class.php";
	require_once $path_to_pChart."class/pDraw.class.php";
	require_once $path_to_pChart."class/pImage.class.php";


 
	// Ctrl existance du dossier image
	verif_existence_rep($path_to_img);

	$y1_title = "Domaine  $domain ";
	$y2_title = "Global Serveur";
	$y3_title = "Externe";

	if($type=="y") {
		$x  = $values[$domain]['y']['date'];
		$y1 = $values[$domain]['y'][$case];
		$y2 = $values['GlobalServer']['y'][$case];
        if ($case != "ingoing" or $case != "ingoingVol") {
    	    $y3 = $values['Externe']['y'][$case] ;
		} ;
        $title    = $case_img[$case]['titley'] ;
		$img = $path_to_img."Y".$this_year."_".$case.".png" ;
    };

    if($type=="m") {
		$x  = $values[$domain]['m']['date'];
		$y1 = $values[$domain]['m'][$case];
		$y2 = $values['GlobalServer']['m'][$case];
		if ($case != "ingoing" or $case!= "ingoingVol") {
            $y3 = $values['Externe']['m'][$case];
		};
        $title    = $case_img[$case]['titlem'] ;
		$img = $path_to_img."M".$this_month."_".$case.".png" ;
	};

	if($type=="w") {
		$x  = $values['w']['hour'];
		$y1 = $values[$domain]['w'][$case];
		$y2 = $values['GlobalServer']['w'][$case];
		if ($case != "ingoing" or $case != "ingoingVol") {
            $y3 = $values['Externe']['w'][$case];
        };
		$title    = $case_img[$case]['titlew'] ;
		$img = $path_to_img."W".$this_week."_".$case.".png" ;
	};

	if($type=="d") {
		$x  = $values['d']['hour'];
		$y1 = $values[$domain]['d'][$case];
		$y2 = $values['GlobalServer']['d'][$case];
        if ( $case != "ingoing" or $case != "ingoingVol") {
		    $y3 = $values['Externe']['d'][$case];
		};
        $title    = $case_img[$case]['titled'] ;
		$img = $path_to_img."D".$this_n_day."_".$case.".png" ;
    };
        $MyData = new pData();


	

    $MyData->addPoints($y1,$y1_title);
	$y1_colorscheme = array("R"=>15,"G"=>44,"B"=>52,"Alpha"=>80);
	$MyData->setPalette($y1_title,$y1_colorscheme);
	
	$compArray = array_diff($y1 ,$y2);

	if(!empty($compArray)) {
	    $MyData->addPoints($y2,$y2_title);
		$y2_colorscheme = array("R"=>184,"G"=>0,"B"=>40,"Alpha"=>80);
	    $MyData->setPalette($y2_title,$y2_colorscheme);
	};

    $MyData->addPoints($y3,$y3_title);
    $y3_colorscheme = array("R"=>240,"G"=>165,"B"=>40,"Alpha"=>80);
    $MyData->setPalette($y3_title,$y3_colorscheme);


    $MyData->addPoints($x,"Labels");
        $MyData->setSerieDescription("Labels","Month");
        $MyData->setAbscissa("Labels");

        /* Create the pChart object */
        $myPicture = new pImage(1000,300,$MyData);

	$myPicture->drawGradientArea(0,0,1000,300,DIRECTION_VERTICAL,array("StartR"=>166,"StartG"=>202,"StartB"=>219,"EndR"=>0,"EndG"=>75,"EndB"=>123,"Alpha"=>100)); 	
	$myPicture->drawGradientArea(0,250,1000,300,DIRECTION_VERTICAL,array("StartR"=>0,"StartG"=>75,"StartB"=>123,"EndR"=>166,"EndG"=>202,"EndB"=>219,"Alpha"=>100));


        $myPicture->drawLine(0,249,1000,249,array("R"=>0,"G"=>0,"B"=>0));
        $myPicture->drawLine(0,250,1000,250,array("R"=>70,"G"=>70,"B"=>70));

        /* Add a border to the picture */
        $myPicture->drawRectangle(0,0,999,299,array("R"=>204,"G"=>204,"B"=>204));

        /* Write the picture title */
        $myPicture->setFontProperties(array("FontName"=>$path_to_pChart."fonts/verdana.ttf","FontSize"=>8));
        $myPicture->drawText(500,14,$title,array("R"=>47,"G"=>47,"B"=>47,"Align"=>TEXT_ALIGN_MIDDLEMIDDLE));

        /* Define the chart area */
        $myPicture->setGraphArea(58,27,980,228);

        /* Draw a rectangle */
       	$myPicture->drawFilledRectangle(58,27,980,228,array("R"=>180,"G"=>180,"B"=>180,"Dash"=>TRUE,"DashR"=>250,"DashG"=>250,"DashB"=>250,"BorderR"=>150,"BorderG"=>150,"BorderB"=>150));

        /* Turn on shadow computing */
        $myPicture->setShadow(TRUE,array("X"=>1,"Y"=>1,"R"=>0,"G"=>0,"B"=>0,"Alpha"=>20));

        /* Draw the scale */
        $myPicture->setFontProperties(array("R"=>47,"G"=>47,"B"=>47));
	if($type=="d") {
        	$ScaleSettings = array("DrawArrows"=>TRUE,"ArrowSize"=>4,"Mode"=>SCALE_MODE_ADDALL_START0,"DrawSubTicks"=>FALSE,"GridR"=>0,"GridG"=>0,"GridB"=>0,"AxisR"=>0,"AxisG"=>0,"AxisB"=>0,"GridAlpha"=>30,"CycleBackground"=>TRUE);
	} else {
		$ScaleSettings = array("DrawArrows"=>TRUE,"ArrowSize"=>4,"DrawXLines"=>FALSE,"Mode"=>SCALE_MODE_ADDALL_START0,"DrawSubTicks"=>FALSE,"GridR"=>0,"GridG"=>0,"GridB"=>0,"AxisR"=>0,"AxisG"=>0,"AxisB"=>0,"GridAlpha"=>30,"CycleBackground"=>TRUE);
	} ;
	$myPicture->drawScale($ScaleSettings);

        /* Draw the spline chart */
        $myPicture->drawSplineChart();

        /* Write the chart boundaries */
        $BoundsSettings = array("MaxDisplayR"=>237,"MaxDisplayG"=>23,"MaxDisplayB"=>48,"MinDisplayR"=>23,"MinDisplayG"=>144,"MinDisplayB"=>237);
        $myPicture->writeBounds(BOUND_BOTH,$BoundsSettings);

         /* Write the chart legend */
        $myPicture->setFontProperties(array("R"=>47,"G"=>47,"B"=>47));
        $myPicture->drawLegend(450,258,array("Style"=>LEGEND_NOBORDER));

        //number_format(, 2, '.', '')

        /* Write the 1st data series statistics */
        $Settings = array("R"=>15,"G"=>44,"B"=>52,"Align"=>TEXT_ALIGN_BOTTOMLEFT);
        $myPicture->drawText(620,265,"Max : ".number_format(ceil($MyData->getMax($y1_title)), 0, '.', ' '),$Settings);
        $myPicture->drawText(700,265,"Min : ".number_format(ceil($MyData->getMin($y1_title)), 0, '.', ' '),$Settings);
        $myPicture->drawText(780,267,"Avg : ".number_format(ceil($MyData->getSerieAverage($y1_title)), 0, '.', ' '),$Settings);
		$myPicture->drawText(860,265,"Tot : ".number_format(ceil(array_sum($y1)), 0, '.', ' '),$Settings);


		if(!empty($compArray)) {
		    /* Write the 2nd data series statistics */
		    $Settings = array("R"=>184,"G"=>0,"B"=>40,"Align"=>TEXT_ALIGN_BOTTOMLEFT);
		    $myPicture->drawText(620,278,"Max : ".number_format(ceil($MyData->getMax($y2_title)), 0, '.', ' '),$Settings);
		    $myPicture->drawText(700,278,"Min : ".number_format(ceil($MyData->getMin($y2_title)), 0, '.', ' '),$Settings);
		    $myPicture->drawText(780,280,"Avg : ".number_format(ceil($MyData->getSerieAverage($y2_title)), 0, '.', ' '),$Settings);
			$myPicture->drawText(860,278,"Tot : ".number_format(ceil(array_sum($y2)), 0, '.', ' '),$Settings);

		    /* Write the 3rd data series statistics if set */
		    $Settings = array("R"=>240,"G"=>165,"B"=>40,"Align"=>TEXT_ALIGN_BOTTOMLEFT);
		    $myPicture->drawText(620,291,"Max : ".number_format(ceil($MyData->getMax($y3_title)), 0, '.', ' '),$Settings);
		    $myPicture->drawText(700,291,"Min : ".number_format(ceil($MyData->getMin($y3_title)), 0, '.', ' '),$Settings);
		    $myPicture->drawText(780,293,"Avg : ".number_format(ceil($MyData->getSerieAverage($y3_title)), 0, '.', ' '),$Settings);
			$myPicture->drawText(860,291,"Tot : ".number_format(ceil(array_sum($y3)), 0, '.', ' '),$Settings);

		} else {
		    /* Write the 3rd data series statistics if set */
		    $Settings = array("R"=>240,"G"=>165,"B"=>40,"Align"=>TEXT_ALIGN_BOTTOMLEFT);
		    $myPicture->drawText(620,278,"Max : ".number_format(ceil($MyData->getMax($y3_title)), 0, '.', ' '),$Settings);
		    $myPicture->drawText(700,278,"Min : ".number_format(ceil($MyData->getMin($y3_title)), 0, '.', ' '),$Settings);
		    $myPicture->drawText(780,280,"Avg : ".number_format(ceil($MyData->getSerieAverage($y3_title)), 0, '.', ' '),$Settings);
			$myPicture->drawText(860,278,"Tot : ".number_format(ceil(array_sum($y3)), 0, '.', ' '),$Settings);
			

		};

        /* Write the Service*/
        //$myPicture->setFontProperties(array("FontName"=>$path_to_pChart."fonts/verdana.ttf","FontSize"=>7));
        //$myPicture->drawText(830,297,"[ Blue-Mind ".date("d/m/Y H:i:s")." ] ",array("R"=>10,"G"=>10,"B"=>10));
	$myPicture->drawFromPNG(5,249,"/usr/share/bm-stats/scripts/PHP/do_graph/logo-bluemind.png");

        /* Render the picture (choose the best way) */
        $myPicture->render($img);
   
};

/* Fin des fonctions locales */


/* JOB */






?>